
#import "CGAView.h"
#import <dpsclient/wraps.h>
#import <dpsclient/psops.h>

@implementation CGAView

- initFrame:(const NXRect *)fr
{
   [super initFrame:fr]; 
   return self; 
}

- awakeFromNib
{
    modo = MEDIUM;

//    [self setDrawSize:493 :337]; 

    radioX = frame.size.width/(MEDIUM_COLUMN+1); 
    radioY = frame.size.height/(COMMON_ROW+1); 

    printf("width=%f  height=%f\n", bounds.size.width, bounds.size.height);
    printf("radioX=%f radioY=%f (%f,%f)\n", radioX, radioY, 
           radioX*MEDIUM_COLUMN, radioY*COMMON_ROW);
   // printf("MIN\n(0,0)->(%f,%f)", )
    return self; 
}


- drawSelf:(const NXRect *)r: (int) count 
{ 
    PSsetgray(NX_BLACK);
    NXRectFill(&bounds);
 
    return self; 
}


- setMode:(int)m
{
    if (m==HIGHT) { 
       modo = m; 
       radioX = frame.size.width/(HIGH_COLUMN+1); 
    } 
    else { 
       modo = MEDIUM;
       radioX = frame.size.width/(MEDIUM_COLUMN+1); 
    }
 //   printf("radioX=%f radioY=%f\n", radioX, radioY);
    [self display];

    return self; 
}

- (int)mode
{
    return modo; 
}

- putPixelInRow:(unsigned)row column:(unsigned)column withColor:(unsigned)color
{
    float x, y; 
    NXRect  rt; 

    [self getFrame: &rt]; 
    [self lockFocus]; 
    PSnewpath(); 
    x = column*radioX; 
    y = rt.size.height - (row+1)*radioY; 
//    x = column; 
//    y = row; 
    PSsetgray(1.0); 
    PSrectfill(x, y,  radioX, radioY); 
    PSstroke(); 
    [window flushWindow]; 
    [self unlockFocus]; 

    printf("[PUT PIXEL (%d, %d)->(%f,%f) de [%f,%f]]\n", row, column, x, y, 
         bounds.size.width, bounds.size.height);
    return self; 
}

- (int) readPixelInRow:(unsigned)row column:(unsigned)column 
{
    return 0; 
}

- mouseDown: (NXEvent *)theEvent 
{
    NXPoint punto=theEvent->location;
    int r,c; 

    [self convertPoint: &punto fromView:nil];  
    r = (int)punto.y;
    c = (int)punto.x; 
    [self putPixelInRow: r column: c withColor: 0]; 
    return self; 
}

@end
