
#import "ControlCGA.h"
#import "tv86.h"
#import <mach/mach.h>

@implementation ControlCGA

extern void init_msg(simpleMsg *m); 
void do_int10_bios(i386_thread_state_t *state);	

static int        *mod; 
/*static VideoTexto *text; */
static int        *pag; 
static id         slf; 
static id         grf; 
static int	  *banderaVideo; 
static i386_thread_state_t *state;

- awakeFromNib 
{
    id newFont; 
    int p, i, j, l; 
    NXRect fr; 
    
    modo   = MODO_TEXTO; 
    pagina = 0; 

    atext[0] = text1; atext[1] = text2; 
    atext[2] = text3; atext[3] = text4; 
    newFont = [Font newFont:"Ohlfs" size:10.0]; 

    apag[0] = pag1; apag[1] = pag2; 
    apag[2] = pag3; apag[3] = pag4; 

    for (i=0; i<4; i++)
       [[atext[i] docView] setFont: newFont]; 

    [self setPagToView: [pag1 contentView]]; 

    for (p=0; p<4; p++) {
        texto[p].row = texto[p].column = 0; 
        for (i=0; i<25; i++)  {
            for (j=0; j<81; j++)
           // texto[p].memVideo[i][j] = (j==80)?((i==24)?'\0':'\n'):'0'+(j%10);         
              texto[p].memVideo[i][j] = (j==80)?((i==24)?'\0':'\n'):' ';         
        }
        l = [[atext[p] docView] textLength]; 
        [[atext[p] docView] setSel:l :l]; 
        [[atext[p] docView] replaceSel:&texto[p].memVideo[0][0]]; 
        [[atext[p] docView] scrollSelToVisible]; 
    } 
    [atext[0] getFrame:&fr]; 
    [graf setFrame:&fr]; 

    bandVideo=0; 
    banderaVideo = &bandVideo; 
    mod = &modo; 
    pag = &pagina; 
 //   text = texto; 
    grf = graf; 
    slf = self; 
    return self; 
}

- setPag:sender
{
     int tmp; 

     tmp =  [[sender selectedCell] tag]; 

     if (tmp<4)  { 
        pagina = tmp; 
        [self setActivePage]; 
     } else {
        [graf setMode:((tmp==4)?MODO_GRAF1:MODO_GRAF2)];
        [self setActiveGraph]; 
     }

     return self;
}

- setActiveGraph 
{
    id newView; 

    newView = [vgraf contentView];
    [self setPagToView: newView]; 

    return self; 
}

- setActivePage 
{
     id newView; 

     newView = [apag[pagina] contentView]; 

/*     switch(pagina) { 
     case 0: newView = [pag1 contentView]; 
             break; 
     case 1: newView = [pag2 contentView]; 
             break; 
     case 2: newView = [pag3 contentView]; 
             break; 
     case 3: newView = [pag4 contentView]; 
             break; 
     }
 */ 
    [self setPagToView: newView]; 

    return self; 
}

- writeToPage: (int) p
{
    int l; 

/*
    [[atext[p] docView] selectAll:atext[p]]; 
    [[atext[p] docView] delete: atext[p]]; 

    l = [[atext[p] docView] textLength]; 
    [[atext[p] docView] setSel:l :l]; 
    [[atext[p] docView] replaceSel:&texto[p].memVideo[0][0]]; 
 */ 
  //  [[atext[p] docView] setAutoDisplay: YES]; 
    [[atext[p] docView] setText: &texto[p].memVideo[0][0]];
    [[atext[p] docView] scrollSelToVisible]; 

    [self setActivePage];  
    return self; 
}

- setPagToView: theView
{
    NXRect boxRect, viewRect; 

    [multiView getFrame: &boxRect]; 
    [theView  getFrame: &viewRect];

    [multiView setContentView: theView];
    NX_X(&viewRect) = (NX_WIDTH(&boxRect)-NX_WIDTH(&viewRect)) / 2.0; 
    NX_Y(&viewRect) = (NX_HEIGHT(&boxRect)-NX_HEIGHT(&viewRect)) / 2.0; 

    [theView setFrame:&viewRect]; 
    [multiView display]; 
    return self; 
}

- display
{
    [[multiView window] makeKeyAndOrderFront: nil]; 
    return self; 
}

void do_int10_bios(i386_thread_state_t *st)	
{
    simpleMsg  mensaje; 
    init_msg(&mensaje); 

    state=st; 
    *banderaVideo=1; 
    mensaje.h.msg_id = SIMULAVIDEO_MSG; 
    mensaje.body[0] ='\0'; 
    mensaje.body[1] = mensaje.body[2] = mensaje.body[3] = '\0'; 
    msg_send((msg_header_t *)&mensaje,MSG_OPTION_NONE,0);
    while(*banderaVideo!=0) ;  
}

- do_int10_bios  // (i386_thread_state_t *state)	
{
    int p, i; 
    unsigned l, r, c;  

/*    printf("Estoy en la simulacion\n"); */ 
    switch(HIGH(state->eax)) {
    case VIDEO_SET_DISPLAY_MODE : 
         i = LOW(state->eax); 
         *mod = (i==MODO_GRAF1 || i==MODO_GRAF2)? i : MODO_TEXTO; 
         if (*mod == MODO_TEXTO) {
            [slf setActivePage]; 
         }
         else { 
           [grf setMode:i];
           [slf setActiveGraph]; 
         }
         break; 
    case VIDEO_SET_CURSOR_TYPE  : 
         /* No implantado */ 
         break; 
    case VIDEO_SET_CSR_POSITION : 
         if (*mod == MODO_TEXTO) {
            i = HIGH(state->ebx); 
            texto[i].row = HIGH(state->edx); 
            texto[i].column = LOW(state->edx); 
         }
         break; 
    case VIDEO_GET_CSR_POSITION : 
         if (*mod == MODO_TEXTO) { 
            i = HIGH(state->ebx); 
            state->ecx = 0; 
            state->edx = (MASK8(texto[i].row)<<8) | (MASK8(texto[i].column));
         }
         break; 
    case VIDEO_GET_PEN_POSITION :
         /* No implantado */ 
         break; 
    case VIDEO_SET_DISPLAY_PAGE : 
         if (*mod == MODO_TEXTO) { 
            *pag = LOW(state->eax);
         }
        [slf setActivePage]; 
         break; 
    case VIDEO_SCROLL_WIN_UP    : break; 
    case VIDEO_SCROLL_WIN_DOWN  : break; 
    case VIDEO_READ_ATRB_CHAR   :  
         i = HIGH(state->ebx); 
         state->eax = 0x00; 
         state->eax = (*mod!=MODO_TEXTO)? 0 : 
                  MASK8(texto[i].memVideo[(texto[i].row)][(texto[i].column)]);
         break;
    case VIDEO_WRITE_ATRB_CHAR  :  
    case VIDEO_WRITE_CHAR_CURSOR: 
         if (*mod = MODO_TEXTO) {
            p = *pag; 
            l = (unsigned) state->ecx; 
            r = texto[p].row; 
            c = texto[p].column; 
            for (i=0; i<l; i++) {
               texto[p].memVideo[r][c] = LOW(state->eax);
               r = (c<79)?r:((r==24)?0:r+1);  
               c = (c<79)?c+1:0; 
            }
            [slf writeToPage: p]; 
         }
         break; 
    case VIDEO_SET_PALETTE      : 
         /* No implantado */ 
         break; 
    case VIDEO_WRITE_PIXEL      : 
         l = LOW(state->eax); 
         c = (unsigned) state->ecx; 
         r = (unsigned) state->edx; 
         [grf putPixelInRow: r column: c withColor:l]; 
         break; 
    case VIDEO_READ_PIXEL       : 
         c = (unsigned) state->ecx; 
         r = (unsigned) state->edx; 
         l = [grf readPixelInRow: r column: c]; 
         state->eax &= 0xffffff00; 
         state->eax |= MASK8(l); 
         break; 
    case VIDEO_TTY_OUT          :
         if (*mod = MODO_TEXTO) {
            p = *pag; 
            l = (unsigned) state->ecx; 
            r = texto[p].row; 
            c = texto[p].column; 
            for (i=0; i<l; i++) {
               texto[p].memVideo[r][c] = LOW(state->eax);
               r = (c<79)?r:((r==24)?0:r+1);  
               c = (c<79)?c+1:0; 
            }
            [slf writeToPage: p]; 
            texto[p].row = r; 
            texto[p].column = c; 
         }
         break; 
    case VIDEO_GET_DISPLAY_MODE	: 
         if (*mod==MODO_TEXTO) { 
            state->eax = (((unsigned)MASK8(80))<<8) 
                       | ((unsigned)MASK8(MODO_TEXTO)); 
            state->ebx &= 0xffff00ff; 
            state->ebx |= (MASK8(*pag)<<8); 
         }
         break;
    }
    return self; 
}

- clearBandera
{
    bandVideo = 0; 
    return self; 
}


@end

/* 
         if (*mod = MODO_TEXTO) { 
            p = *pag; 
            c = (unsigned) state->ecx; 
            for (i=0; i<c; i++) {
               text[p].memVideo[(text[p].row)][(text[p].column)] = 
                        LOW(state->eax);
               if (text[p].column < 79) { 
                   text[p].column++; 
               }
               else {
                   text[p].memVideo[(text[p].row)][80] = '\0';
                   text[p].column = 0; 
                   text[p].row = (text[p].row<23)? (text[p].row+1):0; 
               }
            }
            [slf writePage]; 
         }
         break;  

 */ 
