
/* 
 * Clase que se encarga de fabricar hilos para el i386 ya sea en 
 * modo protegido o en modo virtual 
 */ 
/* 
 *   (c) 1998 Universidad Autonoma de Puebla 
 *   
 *   Departamento de Aplicacion de Microcomputadoras 
 *   Instituto de Ciencias 
 *   Universidad Autonoma de Puebla 
 *   49 Pte. 1102, Col. Prados Agua Azul. 
 *   Puebla, Pue. Mexico  
 */ 
/* 
 * Clase que se encarga de fabricar utilizando el paquete Cthreads.  
 * Amilcar Meneses Viveros 
 * [22-Sep-1998] 
 */ 

#import <appkit/appkit.h>
#import <objc/Object.h>
#import <mach/mach.h>
#import <mach/cthreads.h>
#import <string.h>

@interface ThreadEngine:Object 
{
   cthread_t  a_thread; 
   kern_return_t rtn;
   char *nombre; 
}

- init;
- (kern_return_t) last_error; 
- (thread_t) thread; 
- (cthread_t) cthread; 
- (kern_return_t) abort;
- (int) thread_count;
- (any_t) data; 
- set_data: (any_t) d; 
- detach: obj_detach; 
- fork:(cthread_fn_t)funcion arg:(any_t) argument; 
- join; 
- (int) limit; 
- set_limit: (int) limit;
- (char *) name;
- set_name:(char *) name;
- (void) exit:(any_t) result;
- (kern_return_t) priority:(int) priority: (boolean_t) set_max; 
- (kern_return_t) max_priority:(processor_set_t) processor_set : (int) max_priority; 
- set_serrno_self: (int) error; 


@end 