/* 
 *   (c) 1998 Universidad Autonoma de Puebla 
 *   
 *   Departamento de Aplicacion de Microcomputadoras 
 *   Instituto de Ciencias 
 *   Universidad Autonoma de Puebla 
 *   49 Pte. 1102, Col. Prados Agua Azul. 
 *   Puebla, Pue. Mexico  
 */ 
/* 
 * Clase que se encarga de fabricar utilizando el paquete Cthreads.  
 * Amilcar Meneses Viveros 
 * [22-Sep-1998] 
 */ 

#import <ThreadEngine.h>
#import <mach/cthreads.h>

@implementation ThreadEngine 

/* + alloc
{
    return [self notImplemented:@selector(alloc)];
}
*/ 

- init
{ 
   [super init]; 
   rtn = 0;
   nombre = '\0';
   a_thread= NO_CTHREAD;
   return self; 
}

- (kern_return_t) last_error
{
  return rtn; 
}

- (thread_t) thread; 
{
   return  cthread_thread(a_thread); 
}

- (cthread_t) cthread 
{
   return a_thread; 
}

- (kern_return_t) abort
{
   printf("Entro a abort\n");
   rtn=cthread_abort(a_thread); 

   if (rtn == KERN_SUCCESS) 
      printf("-----Finalizo hilo\n"); 
   else
      printf("-----Problema al finalizar hilo"); 

   printf("...Fin\n");
   return rtn;
}

- (int) thread_count
{
   return cthread_count(); 
}

- (any_t) data
{
   return cthread_data(a_thread); 
}

- set_data: (any_t) d; 
{
   cthread_set_data(a_thread, d); 
   return self;
}

- detach: obj_thread; 
{
//   cthread_detach([obj_thread cthread]); 
   cthread_detach(a_thread);
   return self; 
}

- fork:(cthread_fn_t)funcion arg:(any_t) argument 
{
   cthread_detach((a_thread=cthread_fork(funcion, argument))); 
   return self; 
}


- join
{
   return cthread_join(a_thread); 
}

- (int) limit
{
   return cthread_limit(); 
}

- set_limit: (int) limit
{
   cthread_set_limit(limit); 
   return self; 
}

- (char *) name
{
//   return cthread_name(a_thread); 
    return nombre;
}

- (void) exit:(any_t) result
{
   cthread_exit(result);
}

- set_name: (char *) name;
{
   strcpy(nombre, name);
   cthread_set_name(a_thread, nombre); 
   return self; 
}

- (kern_return_t) priority:(int) priority: (boolean_t) set_max
{
   return cthread_priority(a_thread, priority, set_max); 
}

- (kern_return_t) max_priority:(processor_set_t) processor_set : (int) max_priority 
{ 
   return cthread_max_priority(a_thread, processor_set, max_priority); 
}

- set_serrno_self: (int) error 
{
   cthread_set_errno_self(error); 
   return self; 
}

@end 
