/* 
 *  Desensamblador para 8086/8088 
 *  Depto. Aplicacion de Microcomputadporas.
 *  ICUAP.
 *  Amilcar Meneses Viveros 
 *  [sep-1999]
 *
 *  Posible herror: Las instrucciones AAM y AAD en una parte del manual 
 *                  "The 8086 Family User's Manual", October 1979 
 *                  Marca que son instrucciones de 2 bytes, pero en otra parte
 *                  Las considera como de 4, y en una parte mas considera a AAM de 1  
 *                  Aqui se consideran como de 2 bytes de longitud. 
 * 
 *  La instruccion NOP es equivalente XCHG AX,AX
 * 
 */
 
#import "dasm.h"
#import "tv86.h"

// #import <stdlib.h>

extern void init_msg(simpleMsg *m); 
//extern void muestra(VirtualMode *yo, char *cadena);

int mcop[][16] = {
 {ADD, ADD, ADD, ADD, ADD, ADD, PSH, POP,  OR,  OR,  OR,  OR,  OR,  OR, PSH,  NV},
 {ADC, ADC, ADC, ADC, ADC, ADC, PSH, POP, SBB, SBB, SBB, SBB, SBB, SBB, PSH, POP},
 {AND, AND, AND, AND, AND, AND, SEG, DAA, SUB, SUB, SUB, SUB, SUB, SUB, SEG, DAS},
 {XOR, XOR, XOR, XOR, XOR, XOR, SEG, AAA, CMP, CMP, CMP, CMP, CMP, CMP, SEG, AAS},
 {INC, INC, INC, INC, INC, INC, INC, INC, DEC, DEC, DEC, DEC, DEC, DEC, DEC, DEC},
 {PSH, PSH, PSH, PSH, PSH, PSH, PSH, PSH, POP, POP, POP, POP, POP, POP, POP, POP},
 {NV,  NV,  NV,  NV,  NV,  NV,  NV,  NV,  NV,  NV,  NV,  NV,  NV,  NV,  NV,  NV },
 {JO,  JNO, JB,  JNB, JZ,  JNZ, JNA, JA,  JS,  JNS, JP,  JNP, JL,  JGE, JLE, JG },
 {Imm, Imm, Imm, Imm, TST, TST, XCH, XCH, MOV, MOV, MOV, MOV, MOV, LEA, MOV, POP},
 {XCH, XCH, XCH, XCH, XCH, XCH, XCH, XCH, CBW, CWD, CLL, WAI, PSF, PPF, SAF, LAF},
 {MOV, MOV, MOV, MOV, MVS, MVS, CMS, CMS, TST, TST, STS, STS, LOS, LOS, SCS, SCS},
 {MOV, MOV, MOV, MOV, MOV, MOV, MOV, MOV, MOV, MOV, MOV, MOV, MOV, MOV, MOV, MOV},
 {NV,  NV,  RET, RET, LES, LDS, MOV, MOV, NV,  NV,  RET, RET, INT, INT, INO, IRT},
 {Shf, Shf, Shf, Shf, AAM, AAD, NV,  XLT, ESC, ESC, ESC, ESC, ESC, ESC, ESC, ESC},
 {LNZ, LZ,  LOO, JCZ, IN,  IN,  OUT, OUT, CLL, JMP, JMP, JMP, IN,  IN,  OUT, OUT},
 {LCK, NV,  REP, REP, HLT, CMC, Gr1, Gr1, CLC, STC, CLI, STI, CLD, STD, Gr2, Gr2}};

/* Calculo de direccion efectiva 
 * mod = 00 
 */ 
void dir1(char *linea, char m, char t)
{
  char rm; 
  rm = (m & 0x07); 

  switch(rm){ 
  case 00: strcat(linea, "[BX]+[SI]"); break; 
  case 01: strcat(linea, "[BX]+[DI]"); break; 
  case 02: strcat(linea, "[BP]+[SI]"); break; 
  case 03: strcat(linea, "[BP]+[DI]"); break; 
  case 04: strcat(linea, "[SI]"); break; 
  case 05: strcat(linea, "[DI]"); break; 
  case 06: strcat(linea, "direccion directa"); break; 
  case 07: strcat(linea, "[BX]"); break; 
  default: strcat(linea, "NO hay!!"); break; 
  }
}

/* Calculo de direccion efectiva 
 * mod = 01 
 */ 
void dir2(char *linea, char m, char t)
{
   char rm;
   rm = (m & 0x07);

   switch(rm){
   case 00: strcat(linea, "(BX)+(SI)+D8"); break;
   case 01: strcat(linea, "(BX)+(DI)+D8"); break;
   case 02: strcat(linea, "(BP)+(SI)+D8"); break;
   case 03: strcat(linea, "(BP)+(DI)+D8"); break;
   case 04: strcat(linea, "(SI)+D8"); break;
   case 05: strcat(linea, "(DI)+D8"); break;
   case 06: strcat(linea, "(BP)+D8"); break;
   case 07: strcat(linea, "(BX)+D8"); break;
   default: strcat(linea, "No hay"); break;
   }
}

/* Calculo de direccion efectiva 
 * mod = 10 
 */ 
void dir3(char *linea, char m, char t)
{
   char rm;
   rm = (m & 0x07);

   switch(rm){
   case 00: strcat(linea, "(BX)+(SI)+D16"); break;
   case 01: strcat(linea, "(BX)+(DI)+D16"); break;
   case 02: strcat(linea, "(BP)+(SI)+D16"); break;
   case 03: strcat(linea, "(BP)+(DI)+D16"); break;
   case 04: strcat(linea, "(SI)+D16"); break;
   case 05: strcat(linea, "(DI)+D16"); break;
   case 06: strcat(linea, "(BP)+D16"); break;
   case 07: strcat(linea, "(BX)+D16"); break;
   default: strcat(linea, "No hay"); break;
   }
}

void t_registroSegmento(char *linea, char sr)
{
   switch(sr) {
   case  0: strcat(linea, "ES"); break;
   case  1: strcat(linea, "CS"); break; 
   case  2: strcat(linea, "SS"); break; 
   case  3: strcat(linea, "DS"); break; 
   default: printf("Error!!!\n"); 
            exit(-1); 
            break; 
   }
}

void t_registro(char *linea, char t, char w)
{
   if (w) {
      switch(t) { 
      case 00: strcat(linea, "AX"); break;
      case 01: strcat(linea, "CX"); break;
      case 02: strcat(linea, "DX"); break;
      case 03: strcat(linea, "BX"); break;
      case 04: strcat(linea, "SP"); break;
      case 05: strcat(linea, "BP"); break;
      case 06: strcat(linea, "SI"); break;
      case 07: strcat(linea, "DI"); break; 
      default: strcat(linea, "Reg. no valido"); break;
      }
   }
   else { 
      switch(t) {
      case 00: strcat(linea, "AL"); break;
      case 01: strcat(linea, "CL"); break;
      case 02: strcat(linea, "DL"); break;
      case 03: strcat(linea, "BL"); break;
      case 04: strcat(linea, "AH"); break;
      case 05: strcat(linea, "CH"); break;
      case 06: strcat(linea, "DH"); break;
      case 07: strcat(linea, "BH"); break; 
      default: strcat(linea, "Reg. no valido"); break;
      }
   }
}

/* 
 * Esta funcion atiende un caso 
 * 1) immediate to accumulator	xxxx xxxw | data | data (if w=1) 
 * Funciona para OR 
 */
void immediate_to_accumulator(char *linea, char l, char h, char *mip, int *np) 
{
   char w; 
   char b1[20];

   w = (*mip)&0x01; 

   if (w) { 
      sprintf(b1, "AX, %2.2x%2.2x", *(mip+2), *(mip+1));
      strcat(linea, b1);
      *np = 3; 
   } 
   else {
      sprintf(b1, "AL, %2.2x", *(mip+1));
      strcat(linea, b1);
      *np = 2; 
   } 
}

/* 
 * Esta funcion atiende 1 caso 
 * 1) immediate to register      xxxx w reg | data | data (if w=1)
 * Trabaja con MOV 
 */
void immediate_to_register(char *linea, char l, char h, char *mip, int *np)
{
   char r, w;
   char b1[20];

   r = l & 0x07; 
   w = l & 0x08; 
   w = w >> 3; 
 
   t_registro(linea, r, w); 
   if (w) { 
      sprintf(b1, ",%2.2x%2.2x", (*(mip+2))&0xff, (*(mip+1))&0xff);
      strcat(linea, b1);
      *np = 3; 
   } else { 
      sprintf(b1, ",%2.2x", *(mip+1));
      strcat(linea, b1);
      *np = 2;      
   }
}

/* 
 * Esta funcion atiende 1 caso 
 * 1) Register/memory to/from register     xxxx 10dw | mod reg r/m | D-LO | D-HI
 * Nota: falta hacer modificaciones a dir1, dir2 y dir3 para que inserten 
 *       los valores de los bytes de datos. 
 * Trabaja con MOV, XCHG
 */ 
void regMem_toFrom_Register(char *linea, char l, char h, char *mip, int *np)
{
   char b2, b[20], w, mod, reg, dw; 

   b[0] = '\0';
   b2 = *(mip+1); 
   mod = (b2&0xC0) >> 6; 
   reg = (b2&0x38) >> 3; 
   w = l & 0x01; 

   switch((dw=(l&0x03))) { 
   case 0: /* Instruction Source is specified in REG field */ 
           /* Instruction operate on byte data             */ 
   case 1: /* Instruction operate on word data             */ 
           b2 &= 0x07; 
           if (mod==3) { 
              t_registro(linea, b2&0x07, w); 
              *np = (dw==0)?3:4; 
           }
           else { 
              if (mod==0) {
                 dir1(linea, b2, w); 
                 *np = 2; 
              } 
              else if (mod==1) {
                 dir2(linea, b2, w); 
                 *np = 3; 
              } 
              else if (mod==2) { 
                 dir3(linea, b2, w); 
                 *np = 4; 
              }
           }
           strcat(linea,",");
           t_registro(linea, reg, w);
           break; 
   case 2: /* Instruction destination is specified in REG field */ 
           /* Instruction operate on byte data                  */ 
   case 3: /* Instruction operate on word data                  */ 
           if (mod==3) { 
              t_registro(linea, reg, w); 
              strcat(linea,","); 
              t_registro(linea, b2&0x07, w); 
              *np=2; 
           }
           else { 
              strcat(linea,"["); 
              t_registro(linea, reg, w);            
              strcat(linea,"],");
              if (w==0) { 
                sprintf(b, "%2.2x", *(mip+2)); 
                *np = 3; 
              } else { 
                sprintf(b, "%2.2x%2.2x", *(mip+3),*(mip+2));
                *np = 4; 
              }
              strcat(linea, b);
           } 
           break; 
   default: printf("Error!!!!!!'n"); break; 
   }  
}

/* 
 * Esta funcion atiende 1 caso: 
 * 1) Segment register to register/memory  xxxx 1100 | mod 0 SR r/m| D-LO | D-H
 * Trabaja con MOV 
 */ 
void segmentRegister_to_regMem(char *linea, char l, char h, char *mip, int *np)
{
    char b2, mod, sr;

    b2 = *(mip+1);  
    sr = (b2&0x18)>>3; 
    mod = (b2&0xC0) >> 6;

    t_registroSegmento(linea, sr); 
    strcat(linea,",");
    switch(mod){ 
    case  0: strcat(linea,"["); dir1(linea, b2&0x3, 1); strcat(linea, "]"); 
             break; 
    case  1: strcat(linea,"["); dir2(linea, b2&0x3, 1); strcat(linea, "]"); 
             break; 
    case  2: strcat(linea,"["); dir3(linea, b2&0x3, 1); strcat(linea, "]"); 
             break; 
    case  3: t_registro(linea, b2&0x3, 1); 
             break; 
    default: printf("Error!!!!\n");
             exit(1); 
             break; 
    }    
    *np = 4; 
}

/* 
 * Esta funcion atiende 1 caso: 
 * 1) Register/memory to segment register  xxxx 1110 | mod 0 SR r/m| D-LO | D-H
 * Trabaja con MOV 
 */ 
void regMem_to_segmentRegister(char *linea, char l, char h, char *mip, int *np)
{
   char b2, mod, sr; 

   b2 = *(mip+1); 
   mod = (b2&0xC0)>>6; 
   sr = (b2&0x18)>>3; 

   switch(mod){ 
   case  0: strcat(linea, "["); dir1(linea, b2&0x7, 1); strcat(linea, "]");
            break;
   case  1: strcat(linea, "["); dir2(linea, b2&0x7, 1); strcat(linea, "]");
            break;
   case  2: strcat(linea, "["); dir3(linea, b2&0x3, 1); strcat(linea, "]");
            break;
   case  3: t_registro(linea, b2&0x7, 1);
            break;
   default: printf("Error!!!!\n");
            exit(1);
            break;                        
   }
   strcat(linea, ",");  
   t_registroSegmento(linea, sr);
   *np = 4; 
}


/* 
 * Esta funcion atiende 3 casos: 
 * 1) Register/memory to/from register     xxxx 10dw | mod reg r/m | D-LO | D-HI 
 * 2) Segment register to register/memory  xxxx 1100 | mod 0 SR r/m| D-LO | D-HI 
 * 3) Register/memory to segment register  xxxx 1110 | mod 0 SR r/m| D-LO | D-HI
 * Trabaja con MOV 
 */ 
void regSegMem_toFrom_RegisterSeg(char *linea, char l, char h, char *mip, int *np)
{
   switch(l) { 
   case 0x8: /* Register/memory to/from register */ 
   case 0x9: 
   case 0xA: 
   case 0xB: regMem_toFrom_Register(linea, l, h, mip, np); 
             break;
   case 0xC: /* Segment Register to register/memory */ 
             segmentRegister_to_regMem(linea, l, h, mip, np); 
             break; 
   case 0xE: /* Register/memory to segment register */ 
             regMem_to_segmentRegister(linea, l, h, mip, np);
             break;
   default:  printf("Error!!!!!\n"); 
             exit(1); 
             break; 
   }
}

/* 
 * Esta funcion atiende 2 casos. 
 * 1) immediateRegister to Register/memory      
 *    xxxx 011w | mod 000 rm | D-LO | D-HI | data | data (if w=1)
 * 2) immediateRegister to Register/memory      
 *    xxxx 000w | mod 001 rm | D-LO | D-HI | data | data (if w=1)
 * Trabaja con MOV (1), OR (2)
 */ 
void immediate_to_regMem(char *linea, char l, char h, char *mip, int *np) 
{
   char mod, b2, w, b[20]; 

   w = (*mip)&0x01; 
   b2 = *(mip+1); 
   mod = (b2&0x0C0)>>6; 
   b2 &= 0x07; 
   if (mod==3) {
      t_registro(linea, b2, w); 
      strcat(linea,","); 
      sprintf(b,"%2.2x%2.2x", (*(mip+3)) & 0xff, (*(mip+2))&0xff);
      *np = 4; 
   }
   else { 
      strcat(linea,"["); 
      switch(mod) { 
      case 0: dir1(linea, b2, w); break; 
      case 1: dir2(linea, b2, w); break; 
      case 2: dir3(linea, b2, w); break; 
      }
      strcat(linea,"],"); 
      if (w==0) {
         sprintf(b, "%2.2x", *(mip+4));
         *np = 5; 
      } else  { 
         sprintf(b, "%2.2x%2.2x", *(mip+5),*(mip+4));
         *np = 6; 
      }
   }
   strcat(linea, b); 
}

/* 
 * Esta funcion atiende dos casos 
 * 1) Memory to Acumulator   xxxx 000w | addr-lo | addr-hi 
 * 2) Acumulator to Memory   xxxx 000w | addr-lo | addr-hi 
 * Trabaja con MOV 
 */ 
void acMem_to_acMem(char *linea, char l, char h, char *mip, int *np)
{
   char b2, w, b[20]; 

   w = (*mip)&0x01; 
   b2 = *(mip+1); 
   switch(b2) { 
   case 00: /* Memory to Acumulator             */ 
            /* Instruction operate on byte data */ 
   case 01: /* Instruction operate on word data */ 
            t_registro(linea, (char) 0, w); 
            strcat(linea, ",["); 
            sprintf(b, "%2.2x%2.2x", *(mip+2),*(mip+1));
            strcat(linea, b); 
            strcat(linea, "]"); 
            break; 
   case 02: /* Acumulator to Memory             */ 
            /* Instruction operate on byte data */ 
   case 03: /* Instruction operate on word data */
            strcat(linea, "["); 
            sprintf(b, "%2.2x%2.2x", *(mip+2),*(mip+1));
            strcat(linea, b); 
            strcat(linea, "],"); 
            t_registro(linea, (char) 0, w); 
   } 
}  

/*
 * Esta funcion atiende un caso 
 * 1) Register/memory   xxxx 1111 | mod xxx rm | D-LO | D-HI 
 * Funciona para PUSH, POP, INC
 */
void regMem(char *linea, char l, char h, char *mip, int *np)
{
    char b2, w; 
    unsigned int mod; 

    b2 = *(mip+1); 
    mod = (unsigned int) (b2&0x0C0)>>6; 
    w = (*mip)&0x01; 
    b2 &= 0x07; 


    if (mod == 0x03) { 
       t_registro(linea, b2, w);
       *np = 2; 
    } else { 
      strcat(linea,"["); 
      switch(mod) { 
      case 0: dir1(linea, b2, w); break; 
      case 1: dir2(linea, b2, w); break; 
      case 2: dir3(linea, b2, w); break; 
      }
      strcat(linea,"]"); 
      *np = 4; 
    }
}

/* 
 * Esta funciona atiende un caso: 
 * 1) Register   xxxxx reg 
 * Funciona para PUSH, POP, INC, DEC
 */
void registro(char *linea, char l, char h, char *mip, int *np)
{
   char reg; 
   reg = (*mip) & 0x07; 
   t_registro(linea, reg, (char) 1); 
   *np = 1; 
}

/* 
 * Esta funciona atiende un caso: 
 * 1) Register   xxxxx reg 
 * Funciona para PUSH, POP, SEG 
 */
void registro_segmento(char *linea, char l, char h, char *mip, int *np)
{
   t_registroSegmento(linea, ((*mip)&0x18)>>3); 
   *np = 1; 
}

/* 
 * Esta funciona atiende un caso: 
 * 1) Register with accumulator  xxxxx reg 
 * Funciona para XCHG
 */
void register_with_acumulator(char *linea, char l, char h, char *mip, int *np)
{
   char reg = (*mip)&0x07; 
   strcat(linea, "AX,"); 
   t_registro(linea, reg, (char) 1); 
   *np = 1; 
}

/* 
 * Esta funcion atiende 2 casos: 
 * 1) Accumulator Immed8    xxxx xx0w | DATA-8  
 * 2) Immed8 Accumulator    xxxx xx1w | DATA-8
 * Funciona para IN, OUT
 */
void fixed_port(char *linea, char l, char h, char *mip, int *np)
{
   char b[20]; 

   switch(l&0x02) { 
   case  0: /* Accumulator Immed8 */ 
            strcat(linea, "AL,"); 
            sprintf(b, "%2.2x", *(mip+1)); 
            break; 
   default: /* Immed8 Accumulator */ 
            sprintf(b, "%2.2x", *(mip+1)); 
            strcat(linea, "AL,"); 
            break; 
   }
   *np = 2; 
}

/* 
 * Esta funcion despliega el contenido del siguiente byte a "mip" 
 * y asigna un valor de 1 al contenido de np
 * Funciona para LOOP, JNZ
 */
void next_data8(char *linea, char h, char l, char *mip, int *np)
{
    char b[20]; 
    sprintf(b, "%2.2x ", *(mip+1));
    strcat(linea, b);
    *np = 2; 
}

/* 
 * Esta funcion atiende 1 caso 
 * 1) reg16, mem16	xxxx xxxx | mod reg rm | D-LO | D-HI      
 * Funciona para LEA, LDS, LES
 */
void reg16_from_mem16(char *linea, char h, char l, char *mip, int *np)
{
   char buffer[100];
   char r; 
   r = ((*(mip+1)&0x038)>>0x03); 
   t_registro(linea, r, 1);
   sprintf(buffer, ",%2.2x%2.2x", *(mip+3), *(mip+2)); 
   strcat(linea, buffer); 
   *np = 4; 
}

/* 
 * Esta funcion atiende dos casos: 
 * 1) 1100 1101 | DATA 
 * 2) 1100 1100 
 * Funciona para INT 
 */
void type_int(char *linea, char l, char h, char *mip, int *np)
{
    char buffer[20]; 
    if ( (*mip & 0x01) == 0x01 ) { /* Tipo  especifico */ 
       sprintf(buffer, "%2.2x", *(mip+1)); 
       strcat(linea, buffer); 
       *np = 2; 
    } else {			 /* Tipo 3 */ 
       strcat(linea, "3");
       *np = 1; 
    }
}

/* 
 * Esta funcion atiende 1 caso: 
 * 1) 1101 1xxx | mod yyy rm 
 * 
 */ 
void immediate_and_register(char *linea, char l, char h, char *mip, int *np) 
{
   char eoc, t;  
   char buffer[20]; 

   t = *(mip+1);	/* Obtiene y */ 
   t >>= 3; 
   t &= 0x07; 

   eoc = *mip & 0x07; 	/* Obtiene x */ 
   eoc <<= 3; 
   eoc |= t; 		/* eoc = x+y (concatenacion) */ 

   sprintf(buffer, "%2.2x", eoc);
   strcat(linea, buffer); 
   t_registro(linea, (*(mip+1) >> 0x01f), 0); 
   *np = 2; 
}

/* 
 * Esta funcion atiende 1 caso: 
 * 1) 1101 1xxx | mod yyy rm | D-LO | D-HI
 * 
 */ 
void immediate_and_memory(char *linea, char l, char h, char *mip, int *np)
{
   char eoc, t;  
   char buffer[20]; 

   t = *(mip+1);	/* Obtiene y */ 
   t >>= 3; 
   t &= 0x07; 

   eoc = *mip & 0x07; 	/* Obtiene x */ 
   eoc <<= 3; 
   eoc |= t; 		/* eoc = x+y (concatenacion) */ 

   sprintf(buffer, "%2.2x", eoc);
   strcat(linea, buffer); 
   switch ((*(mip+1) >> 0x01f)) { 
   case  0: dir1(linea, (*(mip+1)&0x07), 0); 
            *np = 2; 
            break; 
   case  1: dir2(linea, (*(mip+1)&0x07), 0); 
            *np = 3; 
            break; 
   case  2: dir3(linea, (*(mip+1)&0x07), 0); 
            *np = 4; 
            break; 
   default: printf("Error!!!\n");
   }
}

void direct_ws_short(char *linea, char l, char h, char *mip, int *np) 
{
    char b[20]; 
     
    sprintf(b, "%c%2.2x ", ( (*(mip+1)&0x0f0)?'-':'+'), (*(mip+1) & 0x0ef));
    strcat(linea, b); 
    *np = 2; 
}

void direct_ws(char *linea, char l, char h, char *mip, int *np)
{
    char b[20]; 
 
    sprintf(b, "%2.2x%2.2x ", *(mip+2), *(mip+1));
    strcat(linea, b); 
    *np = 3; 
}

void direct_intersegment(char *linea, char l, char h, char *mip, int *np)
{
    char b[100];
 
    sprintf(b, "%2.2x%2.2x:%2.2x%2.2x", 
               *(mip+4), *(mip+3), *(mip+2), *(mip+1)); 
    strcat(linea, b); 
    *np = 5; 
}

void reg_or_mem(char *linea, char l, char h, char *mip, int *np) 
{
   char mod, b2, w; 

   w = (*mip)&0x01; 
   b2 = *(mip+1); 
   mod = (b2&0x0C0)>>6; 
   b2 &= 0x07; 
   if (mod==3) { 
      t_registro(linea, b2, w); 
      *np = 2; 
   } 
   else { 
      strcat(linea,"["); 
      switch(mod) { 
      case 0: dir1(linea, b2, w); break; 
              *np = (b2==0x06)? 4: 2; 
      case 1: dir2(linea, b2, w); 
              *np=3;
              break; 
      case 2: dir3(linea, b2, w); 
              *np=4; 
              break; 
      }
      strcat(linea,"]"); 
   }
}


/* 
 * Esta funcion atiende 8 casos: 
 * 1) ADD Register/Memory,Immed	1000 00sw | MOD 000 RM
 * 2) OR  Register/Memory,Immed	1000 000w | MOD 001 RM 
 * 3) ADC Register/Memory,Immed	1000 00sw | MOD 010 RM 
 * 4) SBB Register/Memory,Immed	1000 00sw | MOD 011 RM 	
 * 5) AND Register/Memory,Immed	1000 000w | MOD 100 RM 
 * 6) SUB Register/Memory,Immed	1000 00sw | MOD 101 RM
 * 7) XOR Register/Memory,Immed	1000 000w | MOD 110 RM 
 * 8) CMP Register/Memory,Immed	1000 00sw | MOD 111 RM 
 */ 
void immediate(char *linea, char l, char h, char *mip, int *np)
{
   char mod, rm, b2, bi; 

   b2 = *(mip+1); 
   mod = (b2&0x0C0)>>6; 
   rm = b2&0x07; 
   bi = (b2&0x38)>>3; 

   switch(bi){ 
   case 00: strcat(linea, "ADD  "); break; 
   case 01: strcat(linea, "OR  ");  break; 
   case 02: strcat(linea, "ADC  "); break; 
   case 03: strcat(linea, "SBB  "); break; 
   case 04: strcat(linea, "AND  "); break; 
   case 05: strcat(linea, "SUB  "); break; 
   case 06: strcat(linea, "XOR  "); break; 
   case 07: strcat(linea, "CMP  "); break; 
   }
  immediate_to_regMem(linea, h, l, mip, np);

} 

/* 
 * Esta funcion atiende 7 casos: 
 * 1) ROL Register/Memory,Immed	1101 00vw | MOD 000 RM
 * 2) ROR Register/Memory,Immed	1101 00vw | MOD 001 RM 
 * 3) RCL Register/Memory,Immed	1101 00vw | MOD 010 RM 
 * 4) RCR Register/Memory,Immed	1101 00vw | MOD 011 RM 	
 * 5) SHL Register/Memory,Immed	1101 00vw | MOD 100 RM 
 * 6) SHR Register/Memory,Immed	1101 00vw | MOD 101 RM
 * 7) SAR Register/Memory,Immed	1101 00vw | MOD 111 RM 
 */ 
void shift(char *linea, char l, char h, char *mip, int *np)
{
   char mod, rm, b2, bi, v; 

   b2 = *(mip+1); 
   mod = (b2&0x0C0)>>6; 
   rm = b2&0x07; 
   bi = (b2&0x38)>>3; 
   v = *mip & 0x02; 

   switch(bi){ 
   case 00: strcat(linea, "ROL  "); break; 
   case 01: strcat(linea, "ROR  "); break; 
   case 02: strcat(linea, "RCL  "); break; 
   case 03: strcat(linea, "RCR  "); break; 
   case 04: strcat(linea, "SHL  "); break; 
   case 05: strcat(linea, "SHR  "); break; 
   case 06: strcat(linea, "no existe"); break; 
   case 07: strcat(linea, "SAR  "); break; 
   }

   reg_or_mem(linea, h, l, mip, np);
   if (v == 0x02 )  
      strcat(linea, ",CL"); 
   else 
      strcat(linea, ",1"); 
} 


/* 
 * Esta funcion atiende 7 casos: 
 * 1) TEST Imm_data to reg/mem	1111 011w | MOD 000 RM 	
 * 2) NOT  Register/memory      1111 011w | MOD 010 RM 
 * 3) NEG  REG16/MEM16(intra)   1111 011w | MOD 011 RM 
 * 4) MUL  MEM16(intersegment)  1111 011w | MOD 100 RM 
 * 5) IMUL REG16/MEM16(intra)   1111 011w | MOD 101 RM
 * 6) DIV  MEM16(intersegment)  1111 011w | MOD 110 RM 
 * 7) IDIV MEM16                1111 011w | MOD 111 RM 
 *
 */ 
void grupo1(char *linea, char h, char l, char *mip, int *np)
{
   char mod, rm, b2, bi; 

   b2 = *(mip+1); 
   mod = (b2&0x0C0)>>6; 
   rm = b2&0x07; 
   bi = (b2&0x38)>>3; 

   switch(bi) { 
   case 00: strcat(linea, "TEST  "); 
            immediate_to_regMem(linea, h, l, mip, np);
            break; 
   case 01: strcat(linea, "No existe"); 
            break; 
   case 02: strcat(linea, "NOT "); 
            reg_or_mem(linea, h, l, mip, np);
            break; 
   case 03: strcat(linea, "NEG  "); 
            reg_or_mem(linea, h, l, mip, np);
            break; 
   case 04: strcat(linea, "MUL  "); 
            reg_or_mem(linea, h, l, mip, np);
            break; 
   case 05: strcat(linea, "IMUL "); 
            reg_or_mem(linea, h, l, mip, np);
            break; 
   case 06: strcat(linea, "DIV  ");  
            reg_or_mem(linea, h, l, mip, np);
            break; 
   case 07: strcat(linea, "IDIV  ");  
            reg_or_mem(linea, h, l, mip, np);
            break; 
   } 
}

/* 
 * Esta funcion atiende 7 casos: 
 * 1) INC  Register/memory      1111 111x | MOD 000 RM 		[FUNCIONA]
 * 2) DEC  Register/memory      1111 111x | MOD 001 RM 
 * 3) CALL REG16/MEM16(intra)   1111 1111 | MOD 010 RM 
 * 4) CALL MEM16(intersegment)  1111 1111 | MOD 011 RM 
 * 5) JMP  REG16/MEM16(intra)   1111 1111 | MOD 100 RM
 * 6) JMP  MEM16(intersegment)  1111 1111 | MOD 101 RM 
 * 7) PUSH MEM16                1111 1111 | MOD 110 RM 
 *
 * Funciona para INC 
 */ 
void grupo2(char *linea, char h, char l, char *mip, int *np)
{
   char mod, rm, b2, bi; 

   b2 = *(mip+1); 
   mod = (b2&0x0C0)>>6; 
   rm = b2&0x07; 
   bi = (b2&0x38)>>3; 

   switch(bi) { 
   case 00: strcat(linea, "INC  "); 
//            regMem(linea, h, l, mip, np); 
            reg_or_mem(linea, h, l, mip, np);
            break; 
   case 01: strcat(linea, "DEC  "); 
            reg_or_mem(linea, h, l, mip, np);
            break; 
   case 02: strcat(linea, "CALL "); 
            reg_or_mem(linea, h, l, mip, np);
            break; 
   case 03: strcat(linea, "CALL "); 
            reg_or_mem(linea, h, l, mip, np);
            break; 
   case 04: strcat(linea, "JMP  "); 
            reg_or_mem(linea, h, l, mip, np);
            break; 
   case 05: strcat(linea, "JMP  "); 
            reg_or_mem(linea, h, l, mip, np);
            break; 
   case 06: strcat(linea, "PUSH "); 
            reg_or_mem(linea, h, l, mip, np);
            break; 
   case 07: strcat(linea, "No existe"); break;  
   }      
}

void dasm(int top, char h, char l, char *linea, char *mip, int *np) 
{
   switch(top) { 
   case ADD: strcpy(linea, "ADD  "); 
             if ((l&0x04)==0x04) 	/* immediate to accumulator */ 
                immediate_to_accumulator(linea, h, l, mip, np); 
             else 			/* Register/memory an register to either */ 
                regMem_toFrom_Register(linea, h, l, mip, np); 
             break; 
   case PSH: strcpy(linea, "PUSH "); 
             // if (h==0x0f)            /* Register/memory [Grp2] */ 
             //   regMem(linea, h, l, mip, np); 
             if (h==0x05)        	/* Register         */ 
                registro(linea, h, l, mip, np);
             else 			/* Segment Register */ 
                registro_segmento(linea, h, l, mip, np); 
             break; 
   case POP: strcpy(linea, "POP  "); 
             if (h==0x08) 
                regMem(linea, h, l, mip, np); 
             else if (h==0x05) 
                registro(linea, h, l, mip, np); 
             else 
                registro_segmento(linea, h, l, mip, np); 
             break; 
   case OR : strcpy(linea, "OR   "); 
             // if (h==0x08)		/* immediate to register/memory [Immed]*/ 
             //   immediate_to_regMem(linea, l, h, mip, np); 
             if ((l&0x0C)==0x08)   	/* Register/memory an register to either */ 
                regMem_toFrom_Register(linea, h, l, mip, np); 
             else 			/* immediate to accumulator */ 
                immediate_to_accumulator(linea, h, l, mip, np); 
             break;
   case ADC: strcpy(linea, "ADC  "); 
             if ((l&0x04)==0x04) 	/* immediate to accumulator */ 
                immediate_to_accumulator(linea, h, l, mip, np); 
             else 			/* Register/memory an register to either */ 
                regMem_toFrom_Register(linea, h, l, mip, np); 
             break; 
   case SBB: strcpy(linea, "SBB  "); 
             if ((l&0x0C)==0x0C)        /* immediate to accumulator */
                immediate_to_accumulator(linea, h, l, mip, np);
             else                       /* Register/memory an register to either */ 
                regMem_toFrom_Register(linea, h, l, mip, np);
             break;
   case AND: strcpy(linea, "AND  "); 
             if ((l&0x04)==0x04)        /* immediate to accumulator */
                immediate_to_accumulator(linea, h, l, mip, np);
             else                       /* Register/memory an register to either */ 
                regMem_toFrom_Register(linea, h, l, mip, np);
             break;
   case SEG: strcpy(linea, "SEGMENT  "); 
             registro_segmento(linea, h, l, mip, np);
             break;
   case DAA: strcpy(linea, "DAA  "); 
             *np=1; 			
             break;
   case SUB: strcpy(linea, "SUB  "); 
             if ((l&0x0C)==0x0C)        /* immediate to accumulator */
                immediate_to_accumulator(linea, h, l, mip, np);
             else                       /* Register/memory an register to eithe */ 
                regMem_toFrom_Register(linea, h, l, mip, np);
             break;
   case DAS: strcpy(linea, "DAS  ");	 
             *np=1;
             break;
   case XOR: strcpy(linea, "XOR  "); 
             if ((l&0x04)==0x04)        /* immediate to accumulator */
                immediate_to_accumulator(linea, h, l, mip, np);
             else                       /* Register/memory an register to eithe */ 
                regMem_toFrom_Register(linea, h, l, mip, np);
             break;
   case AAA: strcpy(linea, "AAA  "); 
             *np=1;
             break;
   case CMP: strcpy(linea, "CMP  "); 
             if ((l&0x0C)==0x0C)        /* immediate to accumulator */
                immediate_to_accumulator(linea, h, l, mip, np);
             else                       /* Register/memory an register to eithe */ 
                regMem_toFrom_Register(linea, h, l, mip, np);
             break;
   case AAS: strcpy(linea, "AAS  "); 
             *np=1;
             break;
   case INC: strcpy(linea, "INC  "); 
             registro(linea, h, l, mip, np); 
             break;
   case DEC: strcpy(linea, "DEC  "); 
             registro(linea, h, l, mip, np); 
             break;
   case JO : strcpy(linea, "JO   ");
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JNO: strcpy(linea, "JNO  "); 
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JB : strcpy(linea, "JB   "); 		/* JB/JNAE */
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JNB: strcpy(linea, "JNB  "); 		/* JNB/JAE */
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JZ : strcpy(linea, "JZ   ");		/* JZ/JE */ 
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JNZ: strcpy(linea, "JNZ  "); 		/* JNZ/JNE */ 
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JNA: strcpy(linea, "JNA  "); 		/* JNA/JBE */ 
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JA : strcpy(linea, "JA   ");		/* JA/JNBE */ 
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JS : strcpy(linea, "JS   "); 
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JNS: strcpy(linea, "JNS  "); 
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JP : strcpy(linea, "JP  "); 		/* JP/JPE */ 
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JNP: strcpy(linea, "JNP  "); 		/* JNP/JPO */
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JL : strcpy(linea, "JL   ");		/* JL/JNGE */
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JGE: strcpy(linea, "JGE  "); 		/* JGE/JNL */ 
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JLE: strcpy(linea, "JLE"); 
             direct_ws_short(linea, h, l, mip, np);
             break; 
   case JG : strcpy(linea, "JG   "); 		/* JG/JNLE */ 
             direct_ws_short(linea, h, l, mip, np);
             break;
   case TST: strcpy(linea, "TEST "); 
             if ((l&0x08)==0x08)        /* immediate to accumulator */
                immediate_to_accumulator(linea, h, l, mip, np);
             else                       /* Register/memory an register to eithe */ 
                regMem_toFrom_Register(linea, h, l, mip, np);
             break;
   case XCH: strcpy(linea, "XCHG "); 
             if (h==0x08) 
                regMem_toFrom_Register(linea, h, l, mip, np); 
             else 
                register_with_acumulator(linea, h, l, mip, np);  
             break; 
   case MOV: strcpy(linea, "MOV  "); 	
             if (h == 0x0B) 				/* Un caso    */
                immediate_to_register(linea, l, h, mip, np); 
             else if (h == 0x08) 		/* Tres casos */ 
                regSegMem_toFrom_RegisterSeg(linea, l, h, mip, np); 
             else if (h == 0x0C) 
                immediate_to_regMem(linea, l, h, mip, np); 
             else if (h == 0x0A) 
                acMem_to_acMem(linea, l, h, mip, np); 
             break;
   case LEA: strcpy(linea, "LEA  "); 
             reg16_from_mem16(linea, l, h, mip, np);
             break;
   case CBW: strcpy(linea, "CBW  "); 
             *np=1; 
             break;
   case CWD: strcpy(linea, "CWD  "); 
             *np=1; 
             break;
   case CLL: strcpy(linea, "CALL "); 		/* Call  */ 
             if (l&0x07==0) 
                direct_ws(linea, l, h, mip, np); 
             else 
                direct_intersegment(linea, l, h, mip, np); 
             break;
   case WAI: strcpy(linea, "WAIT ");           /* Wait  */
             *np=1;
             break; 
   case PSF: strcpy(linea, "PUSHF");           /* Pushf */
             *np=1;
             break;
   case PPF: strcpy(linea, "POPF ");           /* Popf  */ 
             *np=1;
             break;
   case SAF: strcpy(linea, "SAHF ");           /* Sahf  */ 
             *np=1;
             break;
   case LAF: strcpy(linea, "LAHF ");           /* Lahf  */ 
             *np=1;
             break;
   case MVS: strcpy(linea, "MOVS ");           /* Movs  */
             *np=1;
             break; 
   case CMS: strcpy(linea, "CMPS ");           /* Cmps  */
             *np=1;
             break; 
   case STS: strcpy(linea, "STOS ");           /* Stos  */ 
             *np=1;
             break;
   case LOS: strcpy(linea, "LODS "); break;    /* Lods  */ 
             *np=1;
             break;
   case SCS: strcpy(linea, "SCAS ");           /* Scas  */ 
             *np=1;
             break;
   case RET: strcpy(linea, "RET  "); 
             if ( (l&0x03)==0x03) 		/* Within segment / Intersegment */ 
                *np = 1; 
             else if( l&0x0b == 0x02) 		/* Withinseg add_imm SP / Interseg add_imm SP */ 
                *np = 3; 
             break;
   case LES: strcpy(linea, "LES  "); 
             reg16_from_mem16(linea, l, h, mip, np);
             break;
   case LDS: strcpy(linea, "LDS  "); 
             reg16_from_mem16(linea, l, h, mip, np);
             break;
   case INT: strcpy(linea, "INT  "); 
             type_int(linea, l, h, mip, np); 
             break;
   case INO: strcpy(linea, "INTO ");           /* Into  */
             *np=1;
             break;
   case IRT: strcpy(linea, "IRT  ");           /* Iret  */ 
             *np=1;
             break;
   case AAM: strcpy(linea, "AAM  "); 
             *np=1;
             break;
   case AAD: strcpy(linea, "AAD  "); break;
             *np=2;
             break;
   case XLT: strcpy(linea, "XLAT ");   		/* Xlat */  /* Sin argumentos */ 
             *np=1;
             break;
   case ESC:   /* 
		* Instruccion ESC 
     		* La instruccion ESC se utiliza para realizar una trea en paralelo con 
		* un coprocesador. ESC envia un codigo de instruccion al coprocesador.
		* El formato de ESC es el siguiente 
	 	* 1) 11011 xxx | mod yyy rm 			<immediate, register> 
 		* 2) 11011 xxx | mod yyy rm | D-LO | D-HI	<immediate, memory> 
 		* Donde: 
 		*  xxx indica cual es el coprocesador subordinado que recibe la  
		*      instruccion 
 		*  yyy indica la instruccion que el coprocesador debe ejecutar 
 		* Los parametros se le pasan a traves de un registro --opcion 1)-- o 
 		* desde la memoria --opcion 2)--.
 		* 
 		* Posibles causa de error
 		* Se esta considerando que cuando mod=11 (se trabajan con registro) se 
		* utilizan registros de 8 bits. 
 		* 
 		* El libro "Microcomputer Systems: The 8086/8088 Family, Architecture, 
  		* Programming, and Design (second edition) de Yu-cheng Liu y Glenn A. 
		* Gibson, Ed. Prentice Hall", sostiene que cuando se trabaja con 
		* registro --opcion 1)-- el codigo de operacion es de 9 bits (en lugar 
		* de 6) y no se toma en cuenta la parte "rm" del segundo  byte. 
 		* (es muy posible que yo no este dando la interpretacion correcta!!!) 
 		*/ 
             strcpy(linea, "ESC  "); 
             if ((*mip&0x07) == 0)  	        /* Immediate, register */  
                immediate_and_register(linea, l, h, mip, np); 
             else 			        /* Immediate, memory   */ 
                immediate_and_memory(linea, l, h, mip, np);
             break;
   case LNZ: strcpy(linea, "LOOPNZ "); 		/* Loopnz / Loopne */ 
             direct_ws_short(linea, h, l, mip, np);
             break; 
   case LZ : strcpy(linea, "LOOPZ  "); 		/* Loopz / Loope   */ 
             direct_ws_short(linea, h, l, mip, np);
             break; 
   case LOO: strcpy(linea, "LOOP ");   		/* Loop   */
             direct_ws_short(linea, h, l, mip, np);
             break;
   case JCZ: strcpy(linea, "JCZ  "); 		/* Jcxz   */ 
             direct_ws_short(linea, h, l, mip, np);
             break; 
   case IN : strcpy(linea, "IN   "); 
             if ((l&0x08)==0x08) { 
                strcat(linea, "AX,DX"); *np = 1; 
             } else fixed_port(linea, h, l, mip, np); 
             break;
   case OUT: strcpy(linea, "OUT  "); 
             if ((l&0x08)==0x08) { 
                strcat(linea, "DX,AL"); *np = 1; 
             } else fixed_port(linea, h, l, mip, np);
             break;
   case LCK: strcpy(linea, "LOCK "); 		/* Lock   */ 
             *np = 1; 
             break; 
   case REP: strcpy(linea, "REP  "); 
             *np = 1; 
             break; 
   case HLT: strcpy(linea, "HLT  "); 
             *np = 1; 
             break;
   case CMC: strcpy(linea, "CMC  "); 
             *np = 1; 
             break;
   case CLC: strcpy(linea, "CLC  "); 
             *np = 1; 
             break; 
   case STC: strcpy(linea, "STC  "); 
             *np = 1; 
             break;
   case CLI: strcpy(linea, "CLI  "); 
             *np = 1; 
             break;
   case STI: strcpy(linea, "STI  "); 
             *np = 1; 
             break;
   case CLD: strcpy(linea, "CLD  "); 
             *np = 1; 
             break;
   case STD: strcpy(linea, "STD  "); 
             *np = 1; 
             break;
   case JMP:   /* 
		* La instruccion JMP, de salto incondicional, tiene tres modos 
		* (sin contar los considerados en Grp2) de operacion: 
		*  1) SHORT: El salto se realiza a la direccion [-128,+127] a partir de 
                *     la direccion actual  
		*  2) NEAR: El salto se realiza a una localidad especifica dentro del 
                *     segmento de codigo actual 
		*  3) FAR: El salto se realiza a una localidad especificada con un 
                *     segmento de codigo y un offset o IP.  
		*/ 
             strcpy(linea, "JMP  "); 
             if (l==0x0B) /* Short */ 
                direct_ws_short(linea, h, l, mip, np);
             else if (l==0x09) /* Direct within segment */ 
                direct_ws(linea, h, l, mip, np);
             else 
                direct_intersegment(linea, h, l, mip, np);
             break;
   case Imm: immediate(linea, h, l, mip, np); 
             break; 
   case Shf: shift(linea, h, l, mip, np);
             break; 
   case Gr1: grupo1(linea, h, l, mip, np); 
              break; 
   case Gr2: grupo2(linea, h, l, mip, np); 
             break; 
   default : strcpy(linea, "Instruccion no valida"); 
   }
}

void desasembler(char *buff, int n)
{
   int ni, nc, np;
   char *mip, h, l;
//  char linea[50];
   simpleMsg mensaje; 
   msg_return_t ret; 

   mip = buff;
   ni = nc = 0;
   init_msg(&mensaje); 

   while (nc < n){
     mensaje.h.msg_id = PROGR_MSG; 
     mensaje.body[0] = '\0';
     np = 5; 
     h = ((*mip) & 0xf0) >> 4;
     l = (*mip) & 0x0f; 

     dasm(mcop[h][l], h, l, mensaje.body, mip, &np); 
     strcat(mensaje.body, "\n");
//     muestra(mensaje.body); 
//     msg_send((msg_header_t *)&mensaje, MSG_OPTION_NONE,0);

     ret=msg_send((msg_header_t *)&mensaje,SEND_NOTIFY, 0);
     switch (ret) {
     case SEND_SUCCESS: printf("SEND_SUCCESS\n"); break; 
     case SEND_INVALID_MEMORY: 
                        printf("SEND_INVALID_MEMORY\n"); break; 
     case SEND_INVALID_PORT: 
                          printf("SEND_INVALID_PORT\n"); break;
     case SEND_TIMED_OUT:
                        printf("SEND_TIMED_OUT\n"); break;
     case SEND_WILL_NOTIFY:
                        printf("SEND_WILL_NOTIFY\n"); break;
     case SEND_NOTIFY_IN_PROGRESS:
                        printf("SEND_NOTIFY_IN_PROGRESS\n"); break;
     default:printf("DESCONOCIDA\n"); break;
     }

//     printf("(%d < %d) %s %d\n",nc, n, mensaje.body, np);
//     printf("%s", mensaje.body);
     mip += np; nc  += np; 
  }
}

